-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib

lib.classes["SHAMAN"] = {}
local t,s,n
lib.classes["SHAMAN"][2] = function()
	cfg.shaman_fs_update=8
	lib.shaman_ll_prio = function()
--		print (lib.GetSpellCD("ll")+lib.GetSpellFullCD("ll"))
		local ll=lib.GetSpellCD("ll")+lib.GetSpellFullCD("ll")+1.5
		if cfg.shaman_fs_update>ll then
			return cfg.shaman_fs_update 
		else
			return ll
		end
	end
	local shaman_buff=0
	lib.AddSpell("sb",{17364}) -- SB
	--lib.AddSpell("sb",{115356}) -- SB
	if lib.KnownSpell("sb") then 
	cfg.spells["sb"].realid=115356
	lib.SetSpellIcon("sb")
	end
	lib.AddSpell("ss",{17364}) -- SS
	lib.AddAura("ss",17364,"debuff","target") -- SS

	--[[lib.SetAuraFunction("ss","OnApply",function() print("SS applied") end)
	lib.SetAuraFunction("ss","OnReApply",function() print("SS re applied") end)]]
	
	lib.AddSpell("ll",{60103}) -- LL
	lib.AddSpell("ifs",{157804}) -- Improved Flame Shock
	lib.AddSpell("sr",{30823}) -- SR
	lib.AddSpell("sw",{51533}) -- Spirit Wolfs
--	lib.AddSpell("wfw",{8232}) -- Windfury Weapon
	lib.AddSpell("frs",{8056}) -- Frost Shock
	lib.AddSpell("lm",{152255}) -- Liquid Magma
	lib.AddSpell("Ascendance",{165341}) -- Ascendance
	lib.AddAura("Ascendance",114051,"buff","player") -- Ascendance
	lib.AddSpell("fn",{1535}) -- FN
	lib.AddAura("mw",53817,"buff","player") -- MW
	lib.AddAura("eote",159103,"buff","player") -- eote
	lib.AddAura("ef",157174,"buff","player") -- EF
	
	cfg.shaman_my=true
		
	cfg.plistdps = {}
	if cfg.shaman_my then

	table.insert(cfg.plistdps,"em_hard")
	table.insert(cfg.plistdps,"as_hard")
	table.insert(cfg.plistdps,"set_heroism")
	table.insert(cfg.plistdps,"fet_heroism")
	table.insert(cfg.plistdps,"sw_heroism")
	table.insert(cfg.plistdps,"Ascendance_heroism")
	table.insert(cfg.plistdps,"Ascendance_eote")

	table.insert(cfg.plistdps,"st_lm")
	table.insert(cfg.plistdps,"lm")
	
	table.insert(cfg.plistdps,"ue_UF")
	table.insert(cfg.plistdps,"eb")
	table.insert(cfg.plistdps,"lb_mw5")
	table.insert(cfg.plistdps,"sb_Ascendance")
	table.insert(cfg.plistdps,"ue_nouf")
	table.insert(cfg.plistdps,"T17_sw")
	table.insert(cfg.plistdps,"T17_ss")
	
	--table.insert(cfg.plistdps,"ll_ef_fs")
	table.insert(cfg.plistdps,"ll_ef")
	table.insert(cfg.plistdps,"ll_2fs")
	table.insert(cfg.plistdps,"ss")
	
	table.insert(cfg.plistdps,"fs_uf_ef")
	table.insert(cfg.plistdps,"frs_ef2")
	table.insert(cfg.plistdps,"ll")
	
	table.insert(cfg.plistdps,"fs_uf")
	table.insert(cfg.plistdps,"fn_3")
	table.insert(cfg.plistdps,"st")
	table.insert(cfg.plistdps,"sw_hard")
	table.insert(cfg.plistdps,"ue")
	table.insert(cfg.plistdps,"fs_nofs")
	table.insert(cfg.plistdps,"frs_ef1")
	table.insert(cfg.plistdps,"fn_2")
	table.insert(cfg.plistdps,"frs_fs")
	table.insert(cfg.plistdps,"lb_mw3")
--	table.insert(cfg.plistdps,"fn_1")
	table.insert(cfg.plistdps,"st_recast")
	
	table.insert(cfg.plistdps,"end")
	
	-- Simulationcraft
	else
	table.insert(cfg.plistdps,"em")
	table.insert(cfg.plistdps,"as")
	table.insert(cfg.plistdps,"fet_heroism")
	table.insert(cfg.plistdps,"sw_heroism")
	table.insert(cfg.plistdps,"Ascendance_heroism")
	table.insert(cfg.plistdps,"Ascendance_eote")
	table.insert(cfg.plistdps,"T17_sw")
	table.insert(cfg.plistdps,"st_lm")
	table.insert(cfg.plistdps,"lm")
	table.insert(cfg.plistdps,"ue_UF")
	table.insert(cfg.plistdps,"eb")
	table.insert(cfg.plistdps,"lb_mw5")
	table.insert(cfg.plistdps,"sb_Ascendance")
	table.insert(cfg.plistdps,"ll_ef_fs")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"ll")
	table.insert(cfg.plistdps,"fs_uf_ef")
	table.insert(cfg.plistdps,"fs_nofs")
--	table.insert(cfg.plistdps,"ue_nouf")

--	table.insert(cfg.plistdps,"T17_ss")
	
--	table.insert(cfg.plistdps,"ll_ef")
	table.insert(cfg.plistdps,"ue")
	table.insert(cfg.plistdps,"frs_ef")
	table.insert(cfg.plistdps,"fn_3")
	table.insert(cfg.plistdps,"lb_mw3")
	table.insert(cfg.plistdps,"sw")
	table.insert(cfg.plistdps,"st")
	--table.insert(cfg.plistdps,"fs_uf")
	table.insert(cfg.plistdps,"fn_2")
	table.insert(cfg.plistdps,"end")
	end
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"mt_lm")
	table.insert(cfg.plistaoe,"lm")
	table.insert(cfg.plistaoe,"fs_aoe")
	table.insert(cfg.plistaoe,"fn")
	table.insert(cfg.plistaoe,"ll_aoe")
	table.insert(cfg.plistaoe,"mt")
	table.insert(cfg.plistaoe,"ue")
	table.insert(cfg.plistaoe,"cl_mw")
	table.insert(cfg.plistaoe,"fs_nouf")
	table.insert(cfg.plistaoe,"ss_no_eote")
	table.insert(cfg.plistaoe,"end")
	
--[[	cfg.plistrange = {}
	table.insert(cfg.plistrange,"ue")
	table.insert(cfg.plistrange,"lvb_fs")
	table.insert(cfg.plistrange,"fs_nofs")
	table.insert(cfg.plistrange,"es_fs")
	table.insert(cfg.plistrange,"fet")
	table.insert(cfg.plistrange,"st")
	table.insert(cfg.plistrange,"lb")
	table.insert(cfg.plistrange,"end")]]
	
	
		
	cfg.plist=cfg.plistdps

	cfg.case = {
		["T17_sw"] = function()
			if lib.SetBonus("T17")==0 then return nil end
			if not cfg.onGround then return nil end
			if lib.hardtarget() then return lib.SimpleCDCheck("sw") end
			return nil
		end,
		["T17_ss"] = function()
			if lib.SetBonus("T17")==0 then return nil end
			if not cfg.onGround then return nil end
			return lib.SimpleCDCheck("ss")
		end,
		["em_hard"] = function()
			if lib.hardtarget() then return lib.SimpleCDCheck("em") end
			return nil
		end,
		["sw_hard"] = function()
			if not cfg.onGround then return nil end
			if lib.hardtarget() then return lib.SimpleCDCheck("sw") end
			return nil
		end,
		["as_hard"] = function()
			if lib.hardtarget() then return lib.SimpleCDCheck("as") end
			return nil
		end,
		["T17_ss"] = function()
			if lib.SetBonus("T17")>0 then return lib.SimpleCDCheck("ss") end
			return nil
		end,
		["Ascendance"] = function()
			if lib.GetAura({"Ascendance"})>0 then return nil end
			if lib.GetSpellCD("ss")>3 then return lib.SimpleCDCheck("Ascendance") end --lib.GetSpellCD("gcd")
			return nil
		end,
		["Ascendance_heroism"] = function()
			if lib.GetAura({"Ascendance"})>0 then return nil end
			if lib.GetAuras("Heroism")>lib.GetSpellCD("Ascendance") and lib.GetSpellCD("ss")>lib.GetSpellCD("gcd") then return lib.SimpleCDCheck("Ascendance") end
			return nil
		end,
		["Ascendance_eote"] = function()
			if lib.GetAura({"Ascendance"})>0 then return nil end
			if not lib.hardtarget() then return nil end
			if lib.GetAura({"eote"})>lib.GetSpellCD("Ascendance") and lib.GetSpellCD("ss")>(lib.GetSpellCD("gcd")+1) then return lib.SimpleCDCheck("Ascendance") end
			return nil
		end,
		["ss_new"] = function ()
			return lib.SimpleCDCheck("ss",(lib.GetAura({"ss"})-1))
		end,
		["ll_2fs"] = function()
			if lib.GetAuraNum("ef")==2 then return nil end
			if lib.KnownSpell("ifs") and cfg.TotalTargets>1 then
				return lib.SimpleCDCheck("ll") 
			end
			return nil
		end,
		["ll_ef"] = function()
			if not cfg.talent_EF then return nil end
			if lib.GetAuraNum("ef")==2 then return nil end
			return lib.SimpleCDCheck("ll") 
		end,
		

		["lm"] = function()
			if not cfg.onGround then return nil end
			if not lib.KnownSpell("lm") then return nil end
			if lib.GetSpellCD("lm")>(45-12) then return nil end 
			if lib.GetTotem(1)>(lib.GetSpellCD("lm")+12) then
				return lib.SimpleCDCheck("lm")
			end
			return nil
		end,
		["st_lm"] = function()
			if not cfg.onGround then return nil end
			if not lib.KnownSpell("lm") then return nil end
			if lib.hardtarget() then return lib.SimpleCDCheck("st",lib.GetTotem(1)) end
			return nil
		end,
		["st_recast"] = function()
			if lib.GetLastSpell({"st"}) then return nil end
			if not cfg.onGround then return nil end
			if lib.HaveTotem("fet") then return nil end
			if lib.GetSpellCD("lm")>(45-12) and lib.GetTotem(1)>0 then return nil end 
			return lib.SimpleCDCheck("st",lib.GetTotem(1)-40,nil,1)
		end,
		["mt_lm"] = function()
			if not cfg.onGround then return nil end
			if not lib.KnownSpell("lm") then return nil end
			return lib.SimpleCDCheck("mt",lib.GetTotem(1))
		end,
		["lm_mt"] = function()
			if not cfg.onGround then return nil end
			if not lib.KnownSpell("lm") then return nil end
--			if lib.GetSpellCD("lm")>(45-12) then return nil end 
			if lib.GetTotem(1)>(lib.GetSpellCD("lm")+12) then return lib.SimpleCDCheck("lm") end
			return lib.SimpleCDCheck("mt",lib.GetSpellCD("lm")-45+12)
		end,
		["sw_heroism"] = function()
			if not cfg.onGround then return nil end
			if lib.GetAuras("Heroism")==0 then return nil end
			return lib.SimpleCDCheck("sw")
		end,
		["ss_no_eote"] = function()
			if lib.GetAura({"eote"})>0 then return nil end
			return lib.SimpleCDCheck("ss")
		end,
		["sb_Ascendance"] = function ()
			if lib.GetAura({"Ascendance"})>lib.GetSpellCD("sb") then
				return lib.SimpleCDCheck("sb")
			end
			return nil
		end,
		["sw"] = function ()
			if not cfg.onGround then return nil end
			if lib.ininstance() then
				if lib.bosstarget() then return lib.SimpleCDCheck("sw") end
			else
				if lib.hardtarget() then return lib.SimpleCDCheck("sw") end
			end
			return nil
		end,
		["ue_UF"] = function()
			if not cfg.talent_UF then return nil end
			return lib.SimpleCDCheck("ue")
		end,
		["ue_nouf"] = function()
			return lib.SimpleCDCheck("ue",lib.GetAura({"uf"}))
		end,
		["ue_fn"] = function()
			if lib.GetSpellCD("fn")<=lib.GetSpellCD("fs") and lib.GetAura({"fs"})>lib.GetSpellCD("ue") then
				return lib.SimpleCDCheck("ue")
			end
			return nil
		end,
		["ll_ef_fs"] = function()
			if not cfg.talent_EF then return nil end
			if lib.GetAuraNum("ef")==2 then return nil end
			if lib.GetBUFF(cfg.targetGUID)<cfg.maxBUFF then return lib.SimpleCDCheck("ll") end
			if lib.GetAura({"fs"})<=lib.shaman_ll_prio() then 
				return lib.SimpleCDCheck("ll") end
			return nil
		end,
		
--[[		["ss"] = function()
			if not cfg.talent_EF then return lib.SimpleCDCheck("ss") end
			if lib.GetAuraNum("ef")==2 then return lib.SimpleCDCheck("ss") end
			if lib.GetAura({"eote"})>0 then
				if lib.GetBUFF(cfg.targetGUID)<cfg.maxBUFF or lib.GetAura({"fs"})<=lib.shaman_ll_prio() then return nil end
			end
			return lib.SimpleCDCheck("ss")
		end,
		["ss"] = function()
			if not cfg.talent_EF then return lib.SimpleCDCheck("ss") end
			if lib.GetAuraNum("ef")==2 then return lib.SimpleCDCheck("ss") end
			if lib.GetAura({"eote"})>0 then
				if lib.GetBUFF(cfg.targetGUID)<cfg.maxBUFF or lib.GetAura({"fs"})<=lib.shaman_ll_prio() then return nil end
			end
			return lib.SimpleCDCheck("ss")
		end,]]
		
		["fs_uf_ef"] = function ()
			if lib.GetAura({"fs"})-lib.GetSpellCD("fs")>30 then return nil end
			shaman_buff=lib.GetAuraNum("ef")+lib.GetAuraNum("uf")
			-- print (shaman_buff.." "..cfg.maxBUFF)
			if cfg.maxBUFF==3 and shaman_buff==cfg.maxBUFF then
				if lib.GetBUFF(cfg.targetGUID)<cfg.maxBUFF then
					return lib.SimpleCDCheck("fs")
				end
				return lib.SimpleCDCheck("fs",(lib.GetAura({"fs"})-cfg.shaman_fs_update))
			end
			return nil
		end,
		["fs_uf"] = function ()
			if lib.GetAura({"fs"})-lib.GetSpellCD("fs")>30 then return nil end
			if cfg.maxBUFF==1 and lib.GetAura({"uf"})>lib.GetSpellCD("fs") then
				if lib.GetBUFF(cfg.targetGUID)<cfg.maxBUFF then
					return lib.SimpleCDCheck("fs")
				else
					return lib.SimpleCDCheck("fs",(lib.GetAura({"fs"})-cfg.shaman_fs_update))
				end
			end
			return nil
		end,
		
		["frs_ef2"] = function ()
			if lib.GetAuraNum("ef")==2
			and lib.GetBUFF(cfg.targetGUID)==cfg.maxBUFF
			and lib.GetAura({"fs"})>lib.shaman_ll_prio()
			and lib.GetAura({"fs"})>cfg.shaman_fs_update+lib.GetSpellCD("frs")+lib.GetSpellFullCD("frs") then
				return lib.SimpleCDCheck("frs")
			end 
			return nil
		end,
		["frs_ef1"] = function ()
			if lib.GetAuraNum("ef")==1
			and lib.GetBUFF(cfg.targetGUID)==cfg.maxBUFF
			and lib.GetAura({"fs"})>lib.shaman_ll_prio()
			and lib.GetAura({"fs"})>cfg.shaman_fs_update+lib.GetSpellCD("frs")+lib.GetSpellFullCD("frs") then
				return lib.SimpleCDCheck("frs")
			end 
			return nil
		end,
		["frs_fs"] = function ()
			if lib.GetBUFF(cfg.targetGUID)<cfg.maxBUFF or lib.GetAura({"fs"})<cfg.shaman_fs_update+lib.GetSpellCD("frs") then
				return nil
			end
			if cfg.maxBUFF==1 then
				if lib.GetAura({"fs"})>cfg.shaman_fs_update+lib.GetSpellCD("frs")+lib.GetSpellFullCD("frs") then
					return lib.SimpleCDCheck("frs")
				end
			else
				if lib.GetAuraNum("ef")==0 then
					if lib.GetAura({"fs"})>cfg.shaman_fs_update+lib.GetSpellCD("frs")+lib.GetSpellFullCD("frs") then
						return lib.SimpleCDCheck("frs")
					end
				else
					if lib.GetAura({"fs"})>lib.shaman_ll_prio() then
						return lib.SimpleCDCheck("frs")
					end
				end
			end
			return nil
		end,
		["fs_ef"] = function ()
			if lib.GetAuraNum("ef")==2 then
				if lib.GetAura({"ef"})>lib.GetSpellCD("fs") then
					return lib.SimpleCDCheck("fs")
				end
			end
			return nil
		end,
		
		["fs_nofs_uf"] = function ()
			if lib.GetAura({"uf"})>lib.GetSpellCD("fs") then
				return lib.SimpleCDCheck("fs",lib.GetSmallest({lib.GetAura({"fs"}),lib.GetAura({"uf"})})-1)
			end
			return nil
		end,
		["fs_nouf"] = function()
			if lib.GetAura({"uf"})==0 then 
				return lib.SimpleCDCheck("fs")
			end
			return nil
		end,
		["frs_no_eote"] = function()
			if lib.GetAura({"eote"})>0 then return nil end
			if lib.GetAura({"fs"})==0 then return nil end
			return lib.SimpleCDCheck("frs")
		end,
		["fs_aoe"] = function ()
			return lib.SimpleCDCheck("fs",lib.GetAura({"fs"})-cfg.shaman_fs_update)
		end,
		["ll_aoe"] = function ()
			if lib.GetAura({"eote"})>0 then 
				if cfg.TotalTargets>1 then return nil end
			end
			if lib.GetAura({"fs"})>cfg.shaman_fs_update then
				return lib.SimpleCDCheck("ll")
			end
			return nil
		end,
		["fn"] = function ()
			if cfg.TotalTargets>1 then
				return lib.SimpleCDCheck("fn")
			end
			return nil
		end,
		["fn_1"] = function ()
			if lib.GetAura({"eote"})>0 then return nil end
			if lib.GetAura({"uf"})>lib.GetSpellCD("fn") then
				if lib.GetSpellCD("ue")<lib.GetAura({"fs"})-2 then
					return lib.SimpleCDCheck("fn")
				else
					return nil
				end
			end
			return lib.SimpleCDCheck("fn")
		end,
		["fn_2"] = function ()
			if cfg.TotalTargets==2 then
				if lib.GetAura({"eote"})>0 then return nil end
				if lib.GetAura({"uf"})>lib.GetSpellCD("fn") then
					if lib.GetAura({"fs"})>lib.GetSpellCD("ue")+cfg.shaman_fs_update then
						return lib.SimpleCDCheck("fn")
					else
						return nil
					end
				end
				return lib.SimpleCDCheck("fn")
			end
			return nil
		end,
		["fn_3"] = function ()
			if cfg.TotalTargets>2 then
				return lib.SimpleCDCheck("fn")
			end
			return nil
		end,
		["lb_mw5"] = function ()
			if lib.GetAuraNum("mw")==5 or lib.GetAura({"as"})>0 then
				return lib.SimpleCDCheck("lb")
			end
			return nil
		end,
		
		["eb"] = function ()
			if lib.SpellCasting() then return nil end
			return lib.SimpleCDCheck("eb")
		end,
		["lb_mw3"] = function ()
			if lib.SpellCasting() then return nil end
			if lib.GetAura({"Ascendance"})>0 then return nil end
			if lib.GetAuraNum("mw")>=3 then
				return lib.SimpleCDCheck("lb")
			end
			return nil
		end,
		["lb_mw2"] = function ()
			if lib.SpellCasting() then return nil end
			if lib.GetAuraNum("mw")>=2 then
				return lib.SimpleCDCheck("lb")
			end
			return nil
		end,
		["lb_mw1"] = function ()
			if lib.SpellCasting() then return nil end
			if lib.GetAuraNum("mw")>=1 then
				return lib.SimpleCDCheck("lb")
			end
			return nil
		end,
		
		["cl"] = function ()
			if lib.SpellCasting("cl") then return nil end
			return lib.SimpleCDCheck("cl")
		end,
		
		["cl_mw"] = function ()
			if lib.GetAuraNum("mw")==5 then
				return lib.SimpleCDCheck("cl")
			end
			return nil
		end,
		
		["es_fs"] = function ()
			if lib.GetAura({"fs"})>(lib.Time2Wait("es")+cfg.shock_cd) then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end
	}

	lib.rangecheck=function()
		if lib.inrange("ll") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("fs") then
			lib.bdcolor(Heddframe.bd,{1,1,0,1})
		elseif lib.inrange("lb") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
--[[		elseif lib.inrange("ue") then
			lib.bdcolor(Heddframe.bd,{0,1,0,1})]]
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	local spell, ef,uf
	function Heddclassevents.COMBAT_LOG_EVENT_UNFILTERED(timeStamp, eventtype,_,sourceGUID,sourceName,_,_,destGUID,destName,_,_,spellId,spellName,_,_,interrupt)
		if sourceGUID == cfg.pguid then
			if eventtype == "SPELL_AURA_APPLIED" or eventtype == "SPELL_AURA_REFRESH" then
				if spellId==lib.GetAuraId("fs") then
					if cfg.spells["fs"].guid==destGUID and lib.SpellInTime("fs",cfg.now-0.2,cfg.now)  then
						ef=lib.GetAuraNum("ef")
						if ef==0 and lib.AuraInTime("ef",cfg.now-0.2,cfg.now) then ef=cfg.auras["ef"].pstacks end
						uf=lib.GetAuraNum("uf")
						if uf==0 and lib.AuraInTime("uf",cfg.now-0.2,cfg.now) then uf=cfg.auras["uf"].pstacks end
						
						lib.SetBUFF(destGUID,(ef+uf))
					else
						lib.SetBUFF(destGUID,0)
					end
				end
			end
			if eventtype == "SPELL_AURA_REFRESH" then
				if spellId==lib.GetAuraId("fs") and cfg.spells["ll"].guid~=destGUID and lib.SpellInTime("ll",cfg.now-0.2,cfg.now) then
					lib.SetBUFF(destGUID,0)
				end
			end
			if eventtype =="SPELL_AURA_REMOVED" then
				if spellId==lib.GetAuraId("fs") then
					lib.SetBUFF(destGUID,0)
				end
			end
		end
		if eventtype == "UNIT_DIED" or eventtype == "UNIT_DESTROYED"  then
			lib.SetBUFF(destGUID,0)
		end
	end
	
	cfg.spells_aoe={"mt"}
	cfg.spells_single={"st"}
	--cfg.spells_range={"lvb"}
	return true
end

lib.classes["SHAMAN"][4] = function()
	lib.AddSpell("ts",{51490}) -- Thunderstorm
	lib.AddSpell("eq",{61882}) -- Earthquake

	cfg.plistdps = {}
	table.insert(cfg.plistdps,"ts_mana")
	table.insert(cfg.plistdps,"ftw")
	table.insert(cfg.plistdps,"shield")
	table.insert(cfg.plistdps,"em")
	table.insert(cfg.plistdps,"fs_nofs")
	table.insert(cfg.plistdps,"lvb_fs")
	table.insert(cfg.plistdps,"es_ls7")
	--table.insert(cfg.plistdps,"es_ls6")
	table.insert(cfg.plistdps,"fet")
	table.insert(cfg.plistdps,"eet")
	table.insert(cfg.plistdps,"st")
	table.insert(cfg.plistdps,"lb")
	table.insert(cfg.plistdps,"ts")
	table.insert(cfg.plistdps,"end")
		
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"ts_mana")
	table.insert(cfg.plistaoe,"ftw")
	--table.insert(cfg.plistaoe,"eq")
	table.insert(cfg.plistaoe,"es_ls7")
	table.insert(cfg.plistaoe,"cl")
	table.insert(cfg.plistaoe,"end")
		
	cfg.plist=cfg.plistdps

	cfg.case = {
		["ts_mana"] = function()
			if cfg.power<2*lib.GetSpellCost("es") then
				return lib.SimpleCDCheck("ts")
			end
			return nil
		end,
		["eq"] = function ()
			if not lib.SpellCasting("eq") then
				return lib.SimpleCDCheck("eq")
			end
			return nil
		end,
		["es_ls6"] = function ()
			if lib.GetAuraNum("shield1")>=6 and lib.GetAura({"fs"})>(lib.Time2Wait("es")+cfg.shock_cd) then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
		["es_ls7"] = function ()
			if lib.GetAuraNum("shield1")>=6 then
				return lib.SimpleCDCheck("es")
			end
			return nil
		end,
	}

	lib.rangecheck=function()
		if lib.inrange("es") then
			lib.bdcolor(Heddframe.bd,nil)
		elseif lib.inrange("lb") then
			lib.bdcolor(Heddframe.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddframe.bd,{1,0,0,1})
		end
	end
	--cfg.spells_aoe={"mt","cl","eq"}
	cfg.spells_single={"lb"}
	return true
end

lib.classevents["SHAMAN"] = function()
	
--	lib.AddSpell("Stormlash",{120668}) -- Stormlash Totem
--	lib.AddAura("Stormlash",120676,"buff","player") -- Stormlash Totem
	lib.AddSpell("st",{3599}) -- Searing Totem
	lib.AddSpell("mt",{8190}) -- Magma Totem
	lib.AddSpell("fet",{2894}) -- Fire Elemental Totem
	lib.AddSpell("ftt",{8227}) -- Flametongue Totem
	lib.AddSpell("eet",{2062}) -- Earth Elemental Totem
	lib.AddSpell("set",{152256}) -- Storm Elemental Totem
	
--[[	cfg.notaoetotem = {}
	if cfg.spells["st"] then cfg.notaoetotem[cfg.spells["st"].name] = true end
	cfg.aoetotem = {}
	if cfg.spells["mt"] then cfg.aoetotem[cfg.spells["mt"].name] = true end
	if cfg.spells["fet"] then cfg.aoetotem[cfg.spells["fet"].name] = true end
	if cfg.spells["ftt"] then cfg.aoetotem[cfg.spells["ftt"].name] = true end]]

	lib.AddSpell("es",{8042}) -- ES
	lib.AddSpell("fs",{8050}) -- FS
	if lib.KnownSpell("fs") then
		cfg.TrackBUFF="fs"
	end
	
	lib.AddAura("fs",8050,"debuff","target") -- FS
	cfg.TrackDOT="fs"
	
	lib.AddSpell("ue",{73680}) -- UE
	lib.AddAura("uf",73683,"buff","player") -- Unleash Flame
	lib.AddSpell("lb",{403}) -- Lightning Bolt
	
-- /script DEFAULT_CHAT_FRAME:AddMessage("\124cffffd000\124Hspell:403\124h[Lightning Bolt]\124h\124r");
	lib.AddSpell("hes",{8004}) -- Healing Surge
	cfg.gcd = "hes"
	
	lib.AddSpell("hex",{51514})
	
	lib.AddSpell("lvb",{51505}) -- Lava Burst
	lib.AddSpell("cl",{421}) -- Chain Lightning
	lib.AddSpell("ftw",{8024}) -- Flametongue Weapon
	lib.AddSpell("shield",{324}) -- Lightning Shield
	lib.AddAuras("shield",{324,52127,974},"buff","player")

	--[[lib.SetAuraFunction("shield1","OnApply",function() print("Shield applied") end)
	lib.SetAuraFunction("shield1","OnReApply",function() print("Shield reapplied") end)
	lib.SetAuraFunction("shield1","OnFade",function() print("Shield faded") end)]]--
	
	
	lib.UpdateTotem(1)
	function lib.mytal()
		cfg.talent_EF=select(5,GetTalentInfo(7,1,GetActiveSpecGroup()))
		cfg.talent_UF=select(5,GetTalentInfo(6,1,GetActiveSpecGroup()))
		cfg.talent_EOTE=select(5,GetTalentInfo(4,3,GetActiveSpecGroup()))
		cfg.maxBUFF=0
		if lib.KnownSpell("ue") then
			cfg.maxBUFF=1
		end
		if cfg.talent_EF then
			cfg.maxBUFF=cfg.maxBUFF+2
		end
	end
	cfg.mode = "dps"
	
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
		
	end
	
	
	
	lib.myonupdate = function()
--		if lib.UpdateWeaponBuffs() then cfg.Update=true end
		lib.GroundUpdate()
	end

	function Heddclassevents.PLAYER_ENTERING_WORLD()
		lib.UpdateTotem(1)
	end
	
	function Heddclassevents.PLAYER_TOTEM_UPDATE(...)
		lib.UpdateTotem(1)
	end
	
	lib.AddSpell("em",{16166}) -- Elemental Mastery 
	lib.AddSpell("as",{16188}) -- Ancestral Swiftness
	lib.AddAura("as",16188,"buff","player") --Ancestral Swiftness
	lib.AddSpell("eb",{117014}) -- Elemental Blast
	
	cfg.case["Stormlash_heroism"] = function()
		if not cfg.onGround then return nil end
		if lib.GetAuras("Heroism")>lib.GetSpellCD("Stormlash") then
			return lib.SimpleCDCheck("Stormlash",lib.GetAura({"Stormlash"}))
		end
		return nil
	end
	
	cfg.case["st"] = function()
		if not cfg.onGround then return nil end
		if not lib.hardtarget() then return nil end
		return lib.SimpleCDCheck("st",lib.GetTotem(1))
	end
	
	cfg.case["mt"] = function()
		if not cfg.onGround then return nil end
		return lib.SimpleCDCheck("mt",lib.GetTotem(1))
	end
	
	cfg.case["fet_heroism"] = function()
		if not cfg.onGround then return nil end
		if lib.GetAuras("Heroism")==0 then return nil end
		return lib.SimpleCDCheck("fet")
	end
	
	cfg.case["set_heroism"] = function()
		if not cfg.onGround then return nil end
		if lib.GetAuras("Heroism")==0 then return nil end
		return lib.SimpleCDCheck("set")
	end
		
	cfg.case["eet_heroism"] = function()
		if not cfg.onGround then return nil end
		if lib.GetAuras("Heroism")==0 then return nil end
--		if lib.GetSpellCD("eet")<lib.GetSpellCD("fet")+60 then return nil end
		return lib.SimpleCDCheck("eet")
	end
	
	cfg.case["st_fs"] = function()
		if not cfg.onGround then return nil end
		if not lib.hardtarget()	then return nil end
		if lib.GetAura({"fs","ss"})>0 then
			return lib.SimpleCDCheck("st",(lib.GetTotem(1)-1))
		end
		return nil
	end
	
	cfg.case["st_5sec"] = function()
		if not cfg.onGround then return nil end
		if not lib.hardtarget() then return nil end
		return lib.SimpleCDCheck("st",(lib.GetTotem(1)-5))
	end
		
	cfg.case["shield"] = function ()
		return lib.SimpleCDCheck("shield",lib.GetAuras("shield"))
	end
	
	cfg.case["fs_nofs"] = function ()
		return lib.SimpleCDCheck("fs",lib.GetAura({"fs"}))
	end
	
	cfg.case["fet"] = function()
		if not cfg.onGround then return nil end
		if lib.ininstance() then
			if lib.bosstarget() then return lib.SimpleCDCheck("fet") end
		else
			if lib.hardtarget() then return lib.SimpleCDCheck("fet") end
		end
		return nil
	end
	
	cfg.case["eet"] = function()
		if not cfg.onGround then return nil end
		if lib.ininstance() then
			if lib.bosstarget() then return lib.SimpleCDCheck("eet") end
		else
			if lib.hardtarget() then return lib.SimpleCDCheck("eet") end
		end
		return nil
	end
	
	cfg.case["lvb_fs"] = function ()
		if lib.SpellCasting("lvb") then return nil end
		if lib.GetLastSpell({"lvb"}) then return nil end
		if lib.GetAura({"fs"})>(lib.Time2Wait("lvb")+lib.GetSpellCT("lvb")) then
			return lib.SimpleCDCheck("lvb")
		end
		return nil
	end
	cfg.set["T17"]={115575,115576,115577,115578,115579}
end